#!/bin/sh -u


#
#	WARNING: Do Not Remove This Section
#
#	$RCSfile: test.sh,v $
#	$Revision: 1.7 $
#	$Date: 2006/02/13 14:47:34 $
#	$Author: zapreevis $
#	
#	MRMC is a model checker for discrete-time and continuous-time Markov reward models.
#	It supports reward extensions of PCTL and CSL (PRCTL and CSRL), and allows for the
#	automated verification of properties concerning long-run and instantaneous rewards
#	as well as cumulative rewards.
#	
#	Copyright (C) The University of Twente, 2004-2006.
#	Authors: Ivan Zapreev
#
#	This program is free software; you can redistribute it and/or
#	modify it under the terms of the GNU General Public License
#	as published by the Free Software Foundation; either version 2
#	of the License, or (at your option) any later version.
#
#	This program is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with this program; if not, write to the Free Software
#	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
#	Our contacts:
#		Formal Methods and Tools Group, University of Twente,
#		P.O. Box 217, 7500 AE Enschede, The Netherlands,
#		Phone: +31 53 4893767, Fax: +31 53 4893247,
#		E-mail: mrmc@cs.utwente.nl
#
#	Source description: This script runs tests
#

TESTS=`eval cat test_list | sed -e '/#.*/d'` ; export TESTS

#%%%%%%%%%%%%EXECUTE TESTS%%%%%%%%%%%%%%%
export PATH=.:${PATH}		#Add local directory to the path, otherwise the tests will not run
export MRMC="../../../bin/mrmc"	#This path is regarding being in the test case directory

for test in ${TESTS}
do
	cd ${test}
	export TEST_NAME=${test}
	echo -n "${test}"
	${test}.sh
	../pf.sh ${test}
	cd ..
done
